{{
Microload V.2


Version: 2.0
Creator: Harrison Saunders(AKA Ravenkallen)
Date of creation: 1/20/12
Date of last revison: 1/20/12


Intro:

The Microload program was made to make loading from a SD card easy using a basic serial terminal, keyboard and TV setup or auto-
execute...


Requirements:

1: Propeller ASC(Arduino Shield Compatible)
2: SD card shield from Sparkfun
3: SD card with at least one file called "autoexec.bin"
Optional:
4: Martin's ASC KVM adapter shield(Or attach your own Keyboard and TV on the same I/O pins)
5: TV and PS/2 Keyboard
6: Serial terminal(Parallax Serial Terminal) 


Instructions:

Simply load any number of Propeller EEPROM files on your SD card and rename one of the files "autoexec.bin". This program will run
if no other user input is given after about 4 seconds. You can make this time longer or shorter by changing the "autodelay" constant



For TV and Keyboard setup:

Simply connect your TV and Keyboard to the KVM adapter and turn power on. You will then be greeted by the boot screen. You can then
press "b" to enter options. You then have a choice of exiting and running "autoexec.bin", rebooting the system or manually entering
a file name to boot from. The file name MUST be a 8.3 filename! Simply press the number that corresponds to the item...


For Serial Terminal:


After power up simply send "?" to the propeller to display the menu and stop the auto countdown. The same exact commands and
rules that work with the TV setup, work with the serial method...




Any questions or comments? Contact me(Ravenkallen) on the Parallax Forums in a PM or E-Mail me at "Harrisonsaunders1991@yahoo.com"








}}


Con
 _clkmode  = xtal1 + pll16x
  _xinfreq  = 5_000_000
   

spiDO     = 12   
spiClk    = 13   
spiDI     = 11   
spiCS     = 8
video     = 16
kbclock   = 23
kbdata    = 22
baud      = 9600
autodelay = 400

Obj
sd:    "fsrwfemto"
loader:    "sdspifemto"
text       : "retrotext"   
kb      : "keyboard"
ser     : "Fullduplexserial" 

Var

long maincog
long ss[50]
long ioControl[2]
long r
byte buffer[12]
byte counter
byte chardata
byte sdfound
long serdata
byte val1, val2

   
Pub bootup | wdcog


kb.start(kbdata, kbclock)   
text.start(video)   
sd.start(@iocontrol)
ser.start(31, 30, 0, baud)
sdfound := 0
text.out(0)
text.color(text#GREEN)  
ser.tx(16)
val1 := 10
text.locate(0,0)  
text.str(string("Microload V.2.1"))
ser.str(string("Microload V.2.1"))
ser.tx(13)
text.locate(0, 4)
text.str(string("Press b to see boot options"))
ser.str(string("Press b to see boot options"))
ser.tx(13)


 


if \sd.mount(spiDO,spiClk,spiDI,spiCS) 
 
 text.locate(0, 2)
 text.str(string("SD not found(Reboot)                  ")) 
 ser.str(string("SD not found(Reboot)                  "))
 ser.tx(13) 
 text.updatescreen
 waitcnt(clkfreq * 3 + cnt)
 bootoptions
 abort
else
 text.locate(0,2)
 text.str(string("Primary Boot Device found(SD)"))
 ser.str(string("Primary Boot Device found(SD)"))

 sdfound := 1 


 



 


text.updatescreen




                          
waitcnt(clkfreq/3 + cnt)

repeat autodelay 
 
   waitcnt(clkfreq/100 + cnt)
   chardata := 0
   readkb
   serdata := ser.rxcheck
   if chardata == "b"
    bootoptions

   if serdata == "b"
    bootoptions

   if val1 == 1
    repeat
     serdata := ser.rxcheck    
     if serdata == "b"
      bootoptions

   
   if serdata == "?"
    ser.tx(16) 
    ser.str(string("Microload V.2.1"))
    ser.tx(13)
    ser.str(string("Press b to see boot options"))
    ser.tx(13)
    if sdfound == 1
     ser.str(string("Primary Boot Device found(SD)"))

    if sdfound == 0
     ser.str(string("SD not found(Reboot)                  "))
    val1 := 1

 
serdata := 0    
maincog := cogid
wdcog:=cognew(wd,@ss)
ser.rxflush
if sd.mount(12,13,11,8) == 0    
                             
  cogstop(wdcog)              

                                
                                
   
                             
  if sd.popen(string("autoexec.bin"), "r") == 0
    sd.bootSDCard
    sd.pclose
          

Pub bootoptions
text.out(0)
text.color(text#GREEN)  
ser.tx(16)
text.locate(0,0)  
text.str(string("Microload V.2.1"))
ser.str(string("Microload V.2.1"))
ser.tx(13)
if sdfound == 1
 ser.tx(13)   
 text.locate(0,2)  
 text.str(string("1 = Boot from AlT file"))
 ser.str(string("1 = Boot from ALT file"))

ser.tx(13)   
text.locate(0,3)  
text.str(string("8 = Reboot"))
ser.str(string("8 = Reboot"))

if sdfound == 1  
 ser.tx(13)   
 text.locate(0,4)  
 text.str(string("9 = Exit"))
 ser.str(string("9 = Exit"))
  
text.updatescreen
repeat
 waitcnt(clkfreq/20 + cnt)
 serdata := 0    
 chardata := 0
 readkb
 serdata := ser.rxcheck


  if serdata == "?"
   ser.tx(16)
   ser.str(string("Microload V.2.1"))    
   if sdfound == 1
    ser.tx(13)
    ser.str(string("1 = Boot from ALT file"))
    ser.tx(13)
    ser.str(string("8 = Reboot"))
   if sdfound == 1  
     ser.tx(13)   
 
     ser.str(string("9 = Exit"))



   
  if chardata == "1"
   secondboot

  if serdata == "1"
   secondboot

  
    
  if chardata == "9"
   Bytemove(@buffer, string("autoexec.bin"), 12)
   bootalt
   quit

  if serdata == "9"
   Bytemove(@buffer, string("autoexec.bin"), 12)  
   bootalt  
   quit


  if chardata == "8"
   text.out(0)
   reboot

  if serdata == "8"
   ser.tx(16)
   reboot



Pub secondboot
text.out(0)
text.color(text#GREEN)  
ser.tx(16)
counter := 0
ser.str(string("Enter ALT file name..."))
text.str(string("Enter ALT file name..."))
ser.tx(13)
ser.str(string("? = Retry"))
ser.tx(13)
text.locate(0,1)
text.str(string("? = Retry"))
text.locate(0,2)  
text.updatescreen
repeat
 chardata := 0
 serdata := 0
 readkb
 serdata := ser.rxcheck
 if serdata == 13
  bootalt
  ser.tx(13)
 if chardata == 13
  bootalt
 
 

 if chardata == "?"
  counter := 0
  text.out(0)
  text.color(text#GREEN)  
  text.locate(0,0)
  text.str(string("Enter ALT file name..."))
  text.locate(0,1)
  text.str(string("? = Retry"))
  text.updatescreen
  bytefill(@buffer, 0, 12)
  chardata := 0




  
 if serdata == "?"
  counter := 0
  ser.tx(16)
  ser.str(string("Enter ALT file name..."))
  ser.tx(13)
  ser.str(string("? = Retry"))
  ser.tx(13)
  bytefill(@buffer, 0, 12)   
  serdata := 0


 if serdata > 0
  buffer[counter] := serdata
  ser.tx(serdata)
  text.locate(counter, 2)
  text.out(serdata)
  counter++

  
  
 if chardata > 0 
  buffer[counter] := chardata
  text.locate(counter, 2)
  text.out(chardata)
  ser.tx(chardata) 
  counter++

 if counter == 13
  text.locate(0,2)
  text.str(@buffer)
  text.updatescreen   
  counter := 0
 waitcnt(clkfreq/15 + cnt)
 text.updatescreen



Pub bootalt | wdcog 
maincog := cogid
wdcog := cognew(wd,@ss)

if sd.mount(12,13,11,8) == 0    
                             
  cogstop(wdcog)              

                                
                                
  if sd.popen(@buffer, "r") <> 0
   text.locate(0,5)     
   text.str(string("No File found... Please Reboot"))
   ser.tx(13)
   ser.str(string("No File Found... Please Reboot"))
   text.updatescreen   
                             
  if sd.popen(@buffer, "r") == 0
    sd.bootSDCard


    

Pub readkb
if kb.gotKey
 chardata := kb.getKey





PRI wd
waitcnt(cnt+clkfreq * 3)

cogstop(maincog)             
loader.bootEEPROM(loader#bootAddr + $8000)      